︠81e79281-5e1c-4452-9df5-7443dcfe820e︠
plot(1 / (1 + 25 * x^2),-1,1)
︡784c9d5f-8d7a-4be4-b96e-924bcc48f7ee︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠167fb1a3-6550-41fe-8446-e82379f840fa︠
def newton_method(f, c, eps, maxiter=100):
    x = f.variables()[0]
    fprime = f.derivative(x)
    try:
        g = f._fast_float_(x)
        gprime = fprime._fast_float_(x)
    except AttributeError:
        g = f; gprime = fprime
    iterates = [c]
    for i in xrange(maxiter):
       fc = g(c)
       if abs(fc) < eps: return c, iterates
       c = c - fc/gprime(c)
       iterates.append(c)
    return c, iterates
    var('x')    
html("<h1>Double Precision Root Finding Using Newton's Method</h1>")
@interact
def _(f = x^2 - 2, c = float(0.5), eps=(-3,(-16..-1)), interval=float(0.5)):
     eps = 10^(eps)
     print "eps = %s"%float(eps)
     time z, iterates = newton_method(f, c, eps)
     print "root =", z
     print "f(c) = %r"%f(x=z)
     n = len(iterates)
     print "iterations =", n
     html(iterates)
     P = plot(f, (x,z-interval, z+interval), rgbcolor='blue')
     h = P.ymax(); j = P.ymin()
     L = sum(point((w,(n-1-float(i))/n*h), rgbcolor=(float(i)/n,0.2,0.3), pointsize=10) + \
             line([(w,h),(w,j)],rgbcolor='black',thickness=0.2) for i,w in enumerate(iterates))
     show(P + L, xmin=z-interval, xmax=z+interval)
︡9a373a97-6ab2-4fe4-ae2a-80edb522f1bf︡{"html": "<font color='black'><h1>Double Precision Root Finding Using Newton's Method</h1></font>"}︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-3\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table>\n<tr><td colspan=3><table><tr><td align=right><font color=\"black\">f&nbsp;</font></td><td><input type=\"text\" value=\"x^2 - 2\" size=80 onchange=\"interact(3, '_interact_.update(\\'3\\', \\'f\\', 1, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'3\\');')\"></input></td>\n</tr><tr><td align=right><font color=\"black\">c&nbsp;</font></td><td><input type=\"text\" value=\"0.5\" size=80 onchange=\"interact(3, '_interact_.update(\\'3\\', \\'c\\', 2, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'3\\');')\"></input></td>\n</tr><tr><td align=right><font color=\"black\">eps&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-eps-3\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-eps-3-lbl\"></font></td></tr></table><script>(function(){ var values = [\"-16\",\"-15\",\"-14\",\"-13\",\"-12\",\"-11\",\"-10\",\"-9\",\"-8\",\"-7\",\"-6\",\"-5\",\"-4\",\"-3\",\"-2\",\"-1\"]; setTimeout(function() {\n    $('#slider-eps-3').slider({\n        step: 1, min: 0, max: 15, value: 13,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-eps-3-lbl').text(values[position]); interact(3, '_interact_.update(\\'3\\', \\'eps\\', 3, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'3\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-eps-3-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-eps-3-lbl').text(values[$('#slider-eps-3').slider('value')]);\n    }, 1); })();</script></td>\n</tr><tr><td align=right><font color=\"black\">interval&nbsp;</font></td><td><input type=\"text\" value=\"0.5\" size=80 onchange=\"interact(3, '_interact_.update(\\'3\\', \\'interval\\', 4, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'3\\');')\"></input></td>\n</tr></table></td></tr>\n<tr><td></td><td style='width: 100%;'><div id=\"cell-interact-3\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td><td></td></tr>\n<tr><td colspan=3></td></tr>\n</table></td>\n                 </tr></table></div>\n                 "}︡
︠16817a24-b728-4519-bcf9-4178a792dfc3︠
@interact
def _(q1=(-1,(-3,3)), q2=(-2,(-3,3)),
      cmap=['autumn', 'bone', 'cool', 'copper', 'gray', 'hot', 'hsv',
           'jet', 'pink', 'prism', 'spring', 'summer', 'winter']):
     x,y = var('x,y')
     f = q1/sqrt((x+1)^2 + y^2) + q2/sqrt((x-1)^2+(y+0.5)^2)
     C = contour_plot(f, (x,-2,2), (y,-2,2), plot_points=30, contours=15, cmap=cmap)
     show(C, figsize=3, aspect_ratio=1)
     show(plot3d(f, (x,-2,2), (y,-2,2)), figsize=5, viewer='tachyon')
︡495cf90a-0402-43c4-bd28-2c2e33461177︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-4\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table>\n<tr><td colspan=3><table><tr><td align=right><font color=\"black\">q1&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-q1-4\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-q1-4-lbl\"></font></td></tr></table><script>(function(){ var values = [\"-3.0\",\"-2.9879759519038078\",\"-2.9759519038076157\",\"-2.9639278557114235\",\"-2.9519038076152313\",\"-2.9398797595190391\",\"-2.927855711422847\",\"-2.9158316633266548\",\"-2.9038076152304626\",\"-2.8917835671342704\",\"-2.8797595190380783\",\"-2.8677354709418861\",\"-2.8557114228456939\",\"-2.8436873747495017\",\"-2.8316633266533096\",\"-2.8196392785571174\",\"-2.8076152304609252\",\"-2.795591182364733\",\"-2.7835671342685409\",\"-2.7715430861723487\",\"-2.7595190380761565\",\"-2.7474949899799643\",\"-2.7354709418837722\",\"-2.72344689378758\",\"-2.7114228456913878\",\"-2.6993987975951956\",\"-2.6873747494990035\",\"-2.6753507014028113\",\"-2.6633266533066191\",\"-2.6513026052104269\",\"-2.6392785571142348\",\"-2.6272545090180426\",\"-2.6152304609218504\",\"-2.6032064128256582\",\"-2.5911823647294661\",\"-2.5791583166332739\",\"-2.5671342685370817\",\"-2.5551102204408895\",\"-2.5430861723446974\",\"-2.5310621242485052\",\"-2.519038076152313\",\"-2.5070140280561208\",\"-2.4949899799599287\",\"-2.4829659318637365\",\"-2.4709418837675443\",\"-2.4589178356713521\",\"-2.44689378757516\",\"-2.4348697394789678\",\"-2.4228456913827756\",\"-2.4108216432865834\",\"-2.3987975951903913\",\"-2.3867735470941991\",\"-2.3747494989980069\",\"-2.3627254509018147\",\"-2.3507014028056226\",\"-2.3386773547094304\",\"-2.3266533066132382\",\"-2.314629258517046\",\"-2.3026052104208539\",\"-2.2905811623246617\",\"-2.2785571142284695\",\"-2.2665330661322773\",\"-2.2545090180360852\",\"-2.242484969939893\",\"-2.2304609218437008\",\"-2.2184368737475086\",\"-2.2064128256513165\",\"-2.1943887775551243\",\"-2.1823647294589321\",\"-2.1703406813627399\",\"-2.1583166332665478\",\"-2.1462925851703556\",\"-2.1342685370741634\",\"-2.1222444889779712\",\"-2.1102204408817791\",\"-2.0981963927855869\",\"-2.0861723446893947\",\"-2.0741482965932025\",\"-2.0621242484970104\",\"-2.0501002004008182\",\"-2.038076152304626\",\"-2.0260521042084338\",\"-2.0140280561122417\",\"-2.0020040080160495\",\"-1.9899799599198571\",\"-1.9779559118236647\",\"-1.9659318637274723\",\"-1.9539078156312799\",\"-1.9418837675350875\",\"-1.9298597194388951\",\"-1.9178356713427027\",\"-1.9058116232465103\",\"-1.8937875751503179\",\"-1.8817635270541255\",\"-1.8697394789579331\",\"-1.8577154308617407\",\"-1.8456913827655483\",\"-1.8336673346693559\",\"-1.8216432865731635\",\"-1.8096192384769711\",\"-1.7975951903807788\",\"-1.7855711422845864\",\"-1.773547094188394\",\"-1.7615230460922016\",\"-1.7494989979960092\",\"-1.7374749498998168\",\"-1.7254509018036244\",\"-1.713426853707432\",\"-1.7014028056112396\",\"-1.6893787575150472\",\"-1.6773547094188548\",\"-1.6653306613226624\",\"-1.65330661322647\",\"-1.6412825651302776\",\"-1.6292585170340852\",\"-1.6172344689378928\",\"-1.6052104208417004\",\"-1.593186372745508\",\"-1.5811623246493156\",\"-1.5691382765531232\",\"-1.5571142284569308\",\"-1.5450901803607384\",\"-1.533066132264546\",\"-1.5210420841683536\",\"-1.5090180360721612\",\"-1.4969939879759688\",\"-1.4849699398797764\",\"-1.472945891783584\",\"-1.4609218436873916\",\"-1.4488977955911992\",\"-1.4368737474950068\",\"-1.4248496993988145\",\"-1.4128256513026221\",\"-1.4008016032064297\",\"-1.3887775551102373\",\"-1.3767535070140449\",\"-1.3647294589178525\",\"-1.3527054108216601\",\"-1.3406813627254677\",\"-1.3286573146292753\",\"-1.3166332665330829\",\"-1.3046092184368905\",\"-1.2925851703406981\",\"-1.2805611222445057\",\"-1.2685370741483133\",\"-1.2565130260521209\",\"-1.2444889779559285\",\"-1.2324649298597361\",\"-1.2204408817635437\",\"-1.2084168336673513\",\"-1.1963927855711589\",\"-1.1843687374749665\",\"-1.1723446893787741\",\"-1.1603206412825817\",\"-1.1482965931863893\",\"-1.1362725450901969\",\"-1.1242484969940045\",\"-1.1122244488978121\",\"-1.1002004008016197\",\"-1.0881763527054273\",\"-1.0761523046092349\",\"-1.0641282565130425\",\"-1.0521042084168502\",\"-1.0400801603206578\",\"-1.0280561122244654\",\"-1.016032064128273\",\"-1.0040080160320806\",\"-0.99198396793588817\",\"-0.97995991983969577\",\"-0.96793587174350337\",\"-0.95591182364731098\",\"-0.94388777555111858\",\"-0.93186372745492618\",\"-0.91983967935873379\",\"-0.90781563126254139\",\"-0.89579158316634899\",\"-0.8837675350701566\",\"-0.8717434869739642\",\"-0.8597194388777718\",\"-0.84769539078157941\",\"-0.83567134268538701\",\"-0.82364729458919461\",\"-0.81162324649300222\",\"-0.79959919839680982\",\"-0.78757515030061742\",\"-0.77555110220442502\",\"-0.76352705410823263\",\"-0.75150300601204023\",\"-0.73947895791584783\",\"-0.72745490981965544\",\"-0.71543086172346304\",\"-0.70340681362727064\",\"-0.69138276553107825\",\"-0.67935871743488585\",\"-0.66733466933869345\",\"-0.65531062124250106\",\"-0.64328657314630866\",\"-0.63126252505011626\",\"-0.61923847695392387\",\"-0.60721442885773147\",\"-0.59519038076153907\",\"-0.58316633266534668\",\"-0.57114228456915428\",\"-0.55911823647296188\",\"-0.54709418837676949\",\"-0.53507014028057709\",\"-0.52304609218438469\",\"-0.5110220440881923\",\"-0.4989979959919999\",\"-0.4869739478958075\",\"-0.47494989979961511\",\"-0.46292585170342271\",\"-0.45090180360723031\",\"-0.43887775551103791\",\"-0.42685370741484552\",\"-0.41482965931865312\",\"-0.40280561122246072\",\"-0.39078156312626833\",\"-0.37875751503007593\",\"-0.36673346693388353\",\"-0.35470941883769114\",\"-0.34268537074149874\",\"-0.33066132264530634\",\"-0.31863727454911395\",\"-0.30661322645292155\",\"-0.29458917835672915\",\"-0.28256513026053676\",\"-0.27054108216434436\",\"-0.25851703406815196\",\"-0.24649298597195957\",\"-0.23446893787576717\",\"-0.22244488977957477\",\"-0.21042084168338238\",\"-0.19839679358718998\",\"-0.18637274549099758\",\"-0.17434869739480519\",\"-0.16232464929861279\",\"-0.15030060120242039\",\"-0.138276553106228\",\"-0.1262525050100356\",\"-0.11422845691384322\",\"-0.10220440881765083\",\"-0.09018036072145845\",\"-0.078156312625266067\",\"-0.066132264529073684\",\"-0.054108216432881301\",\"-0.042084168336688918\",\"-0.030060120240496535\",\"-0.018036072144304152\",\"-0.0060120240481117675\",\"0.0060120240480806171\",\"0.018036072144273003\",\"0.030060120240465386\",\"0.042084168336657769\",\"0.054108216432850152\",\"0.066132264529042542\",\"0.078156312625234925\",\"0.090180360721427308\",\"0.10220440881761969\",\"0.11422845691381207\",\"0.12625250501000446\",\"0.13827655310619685\",\"0.15030060120238925\",\"0.16232464929858165\",\"0.17434869739477404\",\"0.18637274549096644\",\"0.19839679358715884\",\"0.21042084168335123\",\"0.22244488977954363\",\"0.23446893787573603\",\"0.24649298597192842\",\"0.25851703406812082\",\"0.27054108216431322\",\"0.28256513026050561\",\"0.29458917835669801\",\"0.30661322645289041\",\"0.31863727454908281\",\"0.3306613226452752\",\"0.3426853707414676\",\"0.35470941883766\",\"0.36673346693385239\",\"0.37875751503004479\",\"0.39078156312623719\",\"0.40280561122242958\",\"0.41482965931862198\",\"0.42685370741481438\",\"0.43887775551100677\",\"0.45090180360719917\",\"0.46292585170339157\",\"0.47494989979958396\",\"0.48697394789577636\",\"0.49899799599196876\",\"0.5110220440881611\",\"0.52304609218435349\",\"0.53507014028054589\",\"0.54709418837673829\",\"0.55911823647293069\",\"0.57114228456912308\",\"0.58316633266531548\",\"0.59519038076150788\",\"0.60721442885770027\",\"0.61923847695389267\",\"0.63126252505008507\",\"0.64328657314627746\",\"0.65531062124246986\",\"0.66733466933866226\",\"0.67935871743485465\",\"0.69138276553104705\",\"0.70340681362723945\",\"0.71543086172343184\",\"0.72745490981962424\",\"0.73947895791581664\",\"0.75150300601200903\",\"0.76352705410820143\",\"0.77555110220439383\",\"0.78757515030058622\",\"0.79959919839677862\",\"0.81162324649297102\",\"0.82364729458916341\",\"0.83567134268535581\",\"0.84769539078154821\",\"0.8597194388777406\",\"0.871743486973933\",\"0.8837675350701254\",\"0.8957915831663178\",\"0.90781563126251019\",\"0.91983967935870259\",\"0.93186372745489499\",\"0.94388777555108738\",\"0.95591182364727978\",\"0.96793587174347218\",\"0.97995991983966457\",\"0.99198396793585697\",\"1.0040080160320493\",\"1.0160320641282417\",\"1.028056112224434\",\"1.0400801603206264\",\"1.0521042084168188\",\"1.0641282565130112\",\"1.0761523046092036\",\"1.088176352705396\",\"1.1002004008015884\",\"1.1122244488977808\",\"1.1242484969939732\",\"1.1362725450901656\",\"1.148296593186358\",\"1.1603206412825504\",\"1.1723446893787428\",\"1.1843687374749352\",\"1.1963927855711276\",\"1.20841683366732\",\"1.2204408817635124\",\"1.2324649298597048\",\"1.2444889779558972\",\"1.2565130260520896\",\"1.268537074148282\",\"1.2805611222444744\",\"1.2925851703406668\",\"1.3046092184368592\",\"1.3166332665330516\",\"1.328657314629244\",\"1.3406813627254364\",\"1.3527054108216288\",\"1.3647294589178212\",\"1.3767535070140136\",\"1.388777555110206\",\"1.4008016032063983\",\"1.4128256513025907\",\"1.4248496993987831\",\"1.4368737474949755\",\"1.4488977955911679\",\"1.4609218436873603\",\"1.4729458917835527\",\"1.4849699398797451\",\"1.4969939879759375\",\"1.5090180360721299\",\"1.5210420841683223\",\"1.5330661322645147\",\"1.5450901803607071\",\"1.5571142284568995\",\"1.5691382765530919\",\"1.5811623246492843\",\"1.5931863727454767\",\"1.6052104208416691\",\"1.6172344689378615\",\"1.6292585170340539\",\"1.6412825651302463\",\"1.6533066132264387\",\"1.6653306613226311\",\"1.6773547094188235\",\"1.6893787575150159\",\"1.7014028056112083\",\"1.7134268537074007\",\"1.7254509018035931\",\"1.7374749498997855\",\"1.7494989979959779\",\"1.7615230460921703\",\"1.7735470941883626\",\"1.785571142284555\",\"1.7975951903807474\",\"1.8096192384769398\",\"1.8216432865731322\",\"1.8336673346693246\",\"1.845691382765517\",\"1.8577154308617094\",\"1.8697394789579018\",\"1.8817635270540942\",\"1.8937875751502866\",\"1.905811623246479\",\"1.9178356713426714\",\"1.9298597194388638\",\"1.9418837675350562\",\"1.9539078156312486\",\"1.965931863727441\",\"1.9779559118236334\",\"1.9899799599198258\",\"2.002004008016018\",\"2.0140280561122101\",\"2.0260521042084023\",\"2.0380761523045945\",\"2.0501002004007867\",\"2.0621242484969788\",\"2.074148296593171\",\"2.0861723446893632\",\"2.0981963927855554\",\"2.1102204408817475\",\"2.1222444889779397\",\"2.1342685370741319\",\"2.1462925851703241\",\"2.1583166332665162\",\"2.1703406813627084\",\"2.1823647294589006\",\"2.1943887775550928\",\"2.2064128256512849\",\"2.2184368737474771\",\"2.2304609218436693\",\"2.2424849699398615\",\"2.2545090180360536\",\"2.2665330661322458\",\"2.278557114228438\",\"2.2905811623246302\",\"2.3026052104208223\",\"2.3146292585170145\",\"2.3266533066132067\",\"2.3386773547093989\",\"2.350701402805591\",\"2.3627254509017832\",\"2.3747494989979754\",\"2.3867735470941676\",\"2.3987975951903597\",\"2.4108216432865519\",\"2.4228456913827441\",\"2.4348697394789363\",\"2.4468937875751284\",\"2.4589178356713206\",\"2.4709418837675128\",\"2.482965931863705\",\"2.4949899799598971\",\"2.5070140280560893\",\"2.5190380761522815\",\"2.5310621242484737\",\"2.5430861723446658\",\"2.555110220440858\",\"2.5671342685370502\",\"2.5791583166332424\",\"2.5911823647294345\",\"2.6032064128256267\",\"2.6152304609218189\",\"2.6272545090180111\",\"2.6392785571142032\",\"2.6513026052103954\",\"2.6633266533065876\",\"2.6753507014027798\",\"2.6873747494989719\",\"2.6993987975951641\",\"2.7114228456913563\",\"2.7234468937875485\",\"2.7354709418837406\",\"2.7474949899799328\",\"2.759519038076125\",\"2.7715430861723171\",\"2.7835671342685093\",\"2.7955911823647015\",\"2.8076152304608937\",\"2.8196392785570858\",\"2.831663326653278\",\"2.8436873747494702\",\"2.8557114228456624\",\"2.8677354709418545\",\"2.8797595190380467\",\"2.8917835671342389\",\"2.9038076152304311\",\"2.9158316633266232\",\"2.9278557114228154\",\"2.9398797595190076\",\"2.9519038076151998\",\"2.9639278557113919\",\"2.9759519038075841\",\"2.9879759519037763\",\"3.0\"]; setTimeout(function() {\n    $('#slider-q1-4').slider({\n        step: 1, min: 0, max: 499, value: 166,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-q1-4-lbl').text(values[position]); interact(4, '_interact_.update(\\'4\\', \\'q1\\', 5, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'4\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-q1-4-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-q1-4-lbl').text(values[$('#slider-q1-4').slider('value')]);\n    }, 1); })();</script></td>\n</tr><tr><td align=right><font color=\"black\">q2&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-q2-4\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-q2-4-lbl\"></font></td></tr></table><script>(function(){ var values = [\"-3.0\",\"-2.9879759519038078\",\"-2.9759519038076157\",\"-2.9639278557114235\",\"-2.9519038076152313\",\"-2.9398797595190391\",\"-2.927855711422847\",\"-2.9158316633266548\",\"-2.9038076152304626\",\"-2.8917835671342704\",\"-2.8797595190380783\",\"-2.8677354709418861\",\"-2.8557114228456939\",\"-2.8436873747495017\",\"-2.8316633266533096\",\"-2.8196392785571174\",\"-2.8076152304609252\",\"-2.795591182364733\",\"-2.7835671342685409\",\"-2.7715430861723487\",\"-2.7595190380761565\",\"-2.7474949899799643\",\"-2.7354709418837722\",\"-2.72344689378758\",\"-2.7114228456913878\",\"-2.6993987975951956\",\"-2.6873747494990035\",\"-2.6753507014028113\",\"-2.6633266533066191\",\"-2.6513026052104269\",\"-2.6392785571142348\",\"-2.6272545090180426\",\"-2.6152304609218504\",\"-2.6032064128256582\",\"-2.5911823647294661\",\"-2.5791583166332739\",\"-2.5671342685370817\",\"-2.5551102204408895\",\"-2.5430861723446974\",\"-2.5310621242485052\",\"-2.519038076152313\",\"-2.5070140280561208\",\"-2.4949899799599287\",\"-2.4829659318637365\",\"-2.4709418837675443\",\"-2.4589178356713521\",\"-2.44689378757516\",\"-2.4348697394789678\",\"-2.4228456913827756\",\"-2.4108216432865834\",\"-2.3987975951903913\",\"-2.3867735470941991\",\"-2.3747494989980069\",\"-2.3627254509018147\",\"-2.3507014028056226\",\"-2.3386773547094304\",\"-2.3266533066132382\",\"-2.314629258517046\",\"-2.3026052104208539\",\"-2.2905811623246617\",\"-2.2785571142284695\",\"-2.2665330661322773\",\"-2.2545090180360852\",\"-2.242484969939893\",\"-2.2304609218437008\",\"-2.2184368737475086\",\"-2.2064128256513165\",\"-2.1943887775551243\",\"-2.1823647294589321\",\"-2.1703406813627399\",\"-2.1583166332665478\",\"-2.1462925851703556\",\"-2.1342685370741634\",\"-2.1222444889779712\",\"-2.1102204408817791\",\"-2.0981963927855869\",\"-2.0861723446893947\",\"-2.0741482965932025\",\"-2.0621242484970104\",\"-2.0501002004008182\",\"-2.038076152304626\",\"-2.0260521042084338\",\"-2.0140280561122417\",\"-2.0020040080160495\",\"-1.9899799599198571\",\"-1.9779559118236647\",\"-1.9659318637274723\",\"-1.9539078156312799\",\"-1.9418837675350875\",\"-1.9298597194388951\",\"-1.9178356713427027\",\"-1.9058116232465103\",\"-1.8937875751503179\",\"-1.8817635270541255\",\"-1.8697394789579331\",\"-1.8577154308617407\",\"-1.8456913827655483\",\"-1.8336673346693559\",\"-1.8216432865731635\",\"-1.8096192384769711\",\"-1.7975951903807788\",\"-1.7855711422845864\",\"-1.773547094188394\",\"-1.7615230460922016\",\"-1.7494989979960092\",\"-1.7374749498998168\",\"-1.7254509018036244\",\"-1.713426853707432\",\"-1.7014028056112396\",\"-1.6893787575150472\",\"-1.6773547094188548\",\"-1.6653306613226624\",\"-1.65330661322647\",\"-1.6412825651302776\",\"-1.6292585170340852\",\"-1.6172344689378928\",\"-1.6052104208417004\",\"-1.593186372745508\",\"-1.5811623246493156\",\"-1.5691382765531232\",\"-1.5571142284569308\",\"-1.5450901803607384\",\"-1.533066132264546\",\"-1.5210420841683536\",\"-1.5090180360721612\",\"-1.4969939879759688\",\"-1.4849699398797764\",\"-1.472945891783584\",\"-1.4609218436873916\",\"-1.4488977955911992\",\"-1.4368737474950068\",\"-1.4248496993988145\",\"-1.4128256513026221\",\"-1.4008016032064297\",\"-1.3887775551102373\",\"-1.3767535070140449\",\"-1.3647294589178525\",\"-1.3527054108216601\",\"-1.3406813627254677\",\"-1.3286573146292753\",\"-1.3166332665330829\",\"-1.3046092184368905\",\"-1.2925851703406981\",\"-1.2805611222445057\",\"-1.2685370741483133\",\"-1.2565130260521209\",\"-1.2444889779559285\",\"-1.2324649298597361\",\"-1.2204408817635437\",\"-1.2084168336673513\",\"-1.1963927855711589\",\"-1.1843687374749665\",\"-1.1723446893787741\",\"-1.1603206412825817\",\"-1.1482965931863893\",\"-1.1362725450901969\",\"-1.1242484969940045\",\"-1.1122244488978121\",\"-1.1002004008016197\",\"-1.0881763527054273\",\"-1.0761523046092349\",\"-1.0641282565130425\",\"-1.0521042084168502\",\"-1.0400801603206578\",\"-1.0280561122244654\",\"-1.016032064128273\",\"-1.0040080160320806\",\"-0.99198396793588817\",\"-0.97995991983969577\",\"-0.96793587174350337\",\"-0.95591182364731098\",\"-0.94388777555111858\",\"-0.93186372745492618\",\"-0.91983967935873379\",\"-0.90781563126254139\",\"-0.89579158316634899\",\"-0.8837675350701566\",\"-0.8717434869739642\",\"-0.8597194388777718\",\"-0.84769539078157941\",\"-0.83567134268538701\",\"-0.82364729458919461\",\"-0.81162324649300222\",\"-0.79959919839680982\",\"-0.78757515030061742\",\"-0.77555110220442502\",\"-0.76352705410823263\",\"-0.75150300601204023\",\"-0.73947895791584783\",\"-0.72745490981965544\",\"-0.71543086172346304\",\"-0.70340681362727064\",\"-0.69138276553107825\",\"-0.67935871743488585\",\"-0.66733466933869345\",\"-0.65531062124250106\",\"-0.64328657314630866\",\"-0.63126252505011626\",\"-0.61923847695392387\",\"-0.60721442885773147\",\"-0.59519038076153907\",\"-0.58316633266534668\",\"-0.57114228456915428\",\"-0.55911823647296188\",\"-0.54709418837676949\",\"-0.53507014028057709\",\"-0.52304609218438469\",\"-0.5110220440881923\",\"-0.4989979959919999\",\"-0.4869739478958075\",\"-0.47494989979961511\",\"-0.46292585170342271\",\"-0.45090180360723031\",\"-0.43887775551103791\",\"-0.42685370741484552\",\"-0.41482965931865312\",\"-0.40280561122246072\",\"-0.39078156312626833\",\"-0.37875751503007593\",\"-0.36673346693388353\",\"-0.35470941883769114\",\"-0.34268537074149874\",\"-0.33066132264530634\",\"-0.31863727454911395\",\"-0.30661322645292155\",\"-0.29458917835672915\",\"-0.28256513026053676\",\"-0.27054108216434436\",\"-0.25851703406815196\",\"-0.24649298597195957\",\"-0.23446893787576717\",\"-0.22244488977957477\",\"-0.21042084168338238\",\"-0.19839679358718998\",\"-0.18637274549099758\",\"-0.17434869739480519\",\"-0.16232464929861279\",\"-0.15030060120242039\",\"-0.138276553106228\",\"-0.1262525050100356\",\"-0.11422845691384322\",\"-0.10220440881765083\",\"-0.09018036072145845\",\"-0.078156312625266067\",\"-0.066132264529073684\",\"-0.054108216432881301\",\"-0.042084168336688918\",\"-0.030060120240496535\",\"-0.018036072144304152\",\"-0.0060120240481117675\",\"0.0060120240480806171\",\"0.018036072144273003\",\"0.030060120240465386\",\"0.042084168336657769\",\"0.054108216432850152\",\"0.066132264529042542\",\"0.078156312625234925\",\"0.090180360721427308\",\"0.10220440881761969\",\"0.11422845691381207\",\"0.12625250501000446\",\"0.13827655310619685\",\"0.15030060120238925\",\"0.16232464929858165\",\"0.17434869739477404\",\"0.18637274549096644\",\"0.19839679358715884\",\"0.21042084168335123\",\"0.22244488977954363\",\"0.23446893787573603\",\"0.24649298597192842\",\"0.25851703406812082\",\"0.27054108216431322\",\"0.28256513026050561\",\"0.29458917835669801\",\"0.30661322645289041\",\"0.31863727454908281\",\"0.3306613226452752\",\"0.3426853707414676\",\"0.35470941883766\",\"0.36673346693385239\",\"0.37875751503004479\",\"0.39078156312623719\",\"0.40280561122242958\",\"0.41482965931862198\",\"0.42685370741481438\",\"0.43887775551100677\",\"0.45090180360719917\",\"0.46292585170339157\",\"0.47494989979958396\",\"0.48697394789577636\",\"0.49899799599196876\",\"0.5110220440881611\",\"0.52304609218435349\",\"0.53507014028054589\",\"0.54709418837673829\",\"0.55911823647293069\",\"0.57114228456912308\",\"0.58316633266531548\",\"0.59519038076150788\",\"0.60721442885770027\",\"0.61923847695389267\",\"0.63126252505008507\",\"0.64328657314627746\",\"0.65531062124246986\",\"0.66733466933866226\",\"0.67935871743485465\",\"0.69138276553104705\",\"0.70340681362723945\",\"0.71543086172343184\",\"0.72745490981962424\",\"0.73947895791581664\",\"0.75150300601200903\",\"0.76352705410820143\",\"0.77555110220439383\",\"0.78757515030058622\",\"0.79959919839677862\",\"0.81162324649297102\",\"0.82364729458916341\",\"0.83567134268535581\",\"0.84769539078154821\",\"0.8597194388777406\",\"0.871743486973933\",\"0.8837675350701254\",\"0.8957915831663178\",\"0.90781563126251019\",\"0.91983967935870259\",\"0.93186372745489499\",\"0.94388777555108738\",\"0.95591182364727978\",\"0.96793587174347218\",\"0.97995991983966457\",\"0.99198396793585697\",\"1.0040080160320493\",\"1.0160320641282417\",\"1.028056112224434\",\"1.0400801603206264\",\"1.0521042084168188\",\"1.0641282565130112\",\"1.0761523046092036\",\"1.088176352705396\",\"1.1002004008015884\",\"1.1122244488977808\",\"1.1242484969939732\",\"1.1362725450901656\",\"1.148296593186358\",\"1.1603206412825504\",\"1.1723446893787428\",\"1.1843687374749352\",\"1.1963927855711276\",\"1.20841683366732\",\"1.2204408817635124\",\"1.2324649298597048\",\"1.2444889779558972\",\"1.2565130260520896\",\"1.268537074148282\",\"1.2805611222444744\",\"1.2925851703406668\",\"1.3046092184368592\",\"1.3166332665330516\",\"1.328657314629244\",\"1.3406813627254364\",\"1.3527054108216288\",\"1.3647294589178212\",\"1.3767535070140136\",\"1.388777555110206\",\"1.4008016032063983\",\"1.4128256513025907\",\"1.4248496993987831\",\"1.4368737474949755\",\"1.4488977955911679\",\"1.4609218436873603\",\"1.4729458917835527\",\"1.4849699398797451\",\"1.4969939879759375\",\"1.5090180360721299\",\"1.5210420841683223\",\"1.5330661322645147\",\"1.5450901803607071\",\"1.5571142284568995\",\"1.5691382765530919\",\"1.5811623246492843\",\"1.5931863727454767\",\"1.6052104208416691\",\"1.6172344689378615\",\"1.6292585170340539\",\"1.6412825651302463\",\"1.6533066132264387\",\"1.6653306613226311\",\"1.6773547094188235\",\"1.6893787575150159\",\"1.7014028056112083\",\"1.7134268537074007\",\"1.7254509018035931\",\"1.7374749498997855\",\"1.7494989979959779\",\"1.7615230460921703\",\"1.7735470941883626\",\"1.785571142284555\",\"1.7975951903807474\",\"1.8096192384769398\",\"1.8216432865731322\",\"1.8336673346693246\",\"1.845691382765517\",\"1.8577154308617094\",\"1.8697394789579018\",\"1.8817635270540942\",\"1.8937875751502866\",\"1.905811623246479\",\"1.9178356713426714\",\"1.9298597194388638\",\"1.9418837675350562\",\"1.9539078156312486\",\"1.965931863727441\",\"1.9779559118236334\",\"1.9899799599198258\",\"2.002004008016018\",\"2.0140280561122101\",\"2.0260521042084023\",\"2.0380761523045945\",\"2.0501002004007867\",\"2.0621242484969788\",\"2.074148296593171\",\"2.0861723446893632\",\"2.0981963927855554\",\"2.1102204408817475\",\"2.1222444889779397\",\"2.1342685370741319\",\"2.1462925851703241\",\"2.1583166332665162\",\"2.1703406813627084\",\"2.1823647294589006\",\"2.1943887775550928\",\"2.2064128256512849\",\"2.2184368737474771\",\"2.2304609218436693\",\"2.2424849699398615\",\"2.2545090180360536\",\"2.2665330661322458\",\"2.278557114228438\",\"2.2905811623246302\",\"2.3026052104208223\",\"2.3146292585170145\",\"2.3266533066132067\",\"2.3386773547093989\",\"2.350701402805591\",\"2.3627254509017832\",\"2.3747494989979754\",\"2.3867735470941676\",\"2.3987975951903597\",\"2.4108216432865519\",\"2.4228456913827441\",\"2.4348697394789363\",\"2.4468937875751284\",\"2.4589178356713206\",\"2.4709418837675128\",\"2.482965931863705\",\"2.4949899799598971\",\"2.5070140280560893\",\"2.5190380761522815\",\"2.5310621242484737\",\"2.5430861723446658\",\"2.555110220440858\",\"2.5671342685370502\",\"2.5791583166332424\",\"2.5911823647294345\",\"2.6032064128256267\",\"2.6152304609218189\",\"2.6272545090180111\",\"2.6392785571142032\",\"2.6513026052103954\",\"2.6633266533065876\",\"2.6753507014027798\",\"2.6873747494989719\",\"2.6993987975951641\",\"2.7114228456913563\",\"2.7234468937875485\",\"2.7354709418837406\",\"2.7474949899799328\",\"2.759519038076125\",\"2.7715430861723171\",\"2.7835671342685093\",\"2.7955911823647015\",\"2.8076152304608937\",\"2.8196392785570858\",\"2.831663326653278\",\"2.8436873747494702\",\"2.8557114228456624\",\"2.8677354709418545\",\"2.8797595190380467\",\"2.8917835671342389\",\"2.9038076152304311\",\"2.9158316633266232\",\"2.9278557114228154\",\"2.9398797595190076\",\"2.9519038076151998\",\"2.9639278557113919\",\"2.9759519038075841\",\"2.9879759519037763\",\"3.0\"]; setTimeout(function() {\n    $('#slider-q2-4').slider({\n        step: 1, min: 0, max: 499, value: 83,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-q2-4-lbl').text(values[position]); interact(4, '_interact_.update(\\'4\\', \\'q2\\', 6, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'4\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-q2-4-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-q2-4-lbl').text(values[$('#slider-q2-4').slider('value')]);\n    }, 1); })();</script></td>\n</tr><tr><td align=right><font color=\"black\">cmap&nbsp;</font></td><td><select onchange=\"interact(4, '_interact_.update(\\'4\\', \\'cmap\\', 7, _interact_.standard_b64decode(\\''+encode64(this.options[this.selectedIndex].value)+'\\'), globals()); _interact_.recompute(\\'4\\');');\"><option value=\"0\" selected>autumn</option>\n<option value=\"1\" >bone</option>\n<option value=\"2\" >cool</option>\n<option value=\"3\" >copper</option>\n<option value=\"4\" >gray</option>\n<option value=\"5\" >hot</option>\n<option value=\"6\" >hsv</option>\n<option value=\"7\" >jet</option>\n<option value=\"8\" >pink</option>\n<option value=\"9\" >prism</option>\n<option value=\"10\" >spring</option>\n<option value=\"11\" >summer</option>\n<option value=\"12\" >winter</option>\n</select></td>\n</tr></table></td></tr>\n<tr><td></td><td style='width: 100%;'><div id=\"cell-interact-4\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td><td></td></tr>\n<tr><td colspan=3></td></tr>\n</table></td>\n                 </tr></table></div>\n                 "}︡
︠d2e2036b-2a91-4e62-842b-04664e18b4bd︠
var('x')
@interact
def midpoint(n = slider(1,100,1,4), f = input_box(default = "x^2", type = str), start = input_box(default = "0", type = str), end = input_box(default = "1", type = str)):
    a = N(start)
    b = N(end)
    func = sage_eval(f, locals={'x':x})
    dx = (b-a)/n
    midxs = [q*dx+dx/2 + a for q in range(n)]
    midys = [func(x_val) for x_val in midxs]
    rects = Graphics()
    for q in range(n):
        xm = midxs[q]
        ym = midys[q]
        rects = rects + line([[xm-dx/2,0],[xm-dx/2,ym],[xm+dx/2,ym],[xm+dx/2,0]], rgbcolor = (1,0,0)) + point((xm,ym), rgbcolor = (1,0,0))
    min_y = find_minimum_on_interval(func,a,b)[0]
    max_y = find_maximum_on_interval(func,a,b)[0]
    html('<h3>Numerical integrals with the midpoint rule</h3>')
    html('$\int_{a}^{b}{f(x) dx} {\\approx} \sum_i{f(x_i) \Delta x}$')
    print "\n\nSage numerical answer: " + str(integral_numerical(func,a,b,max_points = 200)[0])
    print "Midpoint estimated answer: " + str(RDF(dx*sum([midys[q] for q in range(n)])))
    show(plot(func,a,b) + rects, xmin = a, xmax = b, ymin = min_y, ymax = max_y)
︡6408ea1e-35c6-47f8-a0c7-3d972faac356︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-5\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table>\n<tr><td colspan=3><table><tr><td align=right><font color=\"black\">n&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-n-5\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-n-5-lbl\"></font></td></tr></table><script>(function(){ var values = [\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\",\"20\",\"21\",\"22\",\"23\",\"24\",\"25\",\"26\",\"27\",\"28\",\"29\",\"30\",\"31\",\"32\",\"33\",\"34\",\"35\",\"36\",\"37\",\"38\",\"39\",\"40\",\"41\",\"42\",\"43\",\"44\",\"45\",\"46\",\"47\",\"48\",\"49\",\"50\",\"51\",\"52\",\"53\",\"54\",\"55\",\"56\",\"57\",\"58\",\"59\",\"60\",\"61\",\"62\",\"63\",\"64\",\"65\",\"66\",\"67\",\"68\",\"69\",\"70\",\"71\",\"72\",\"73\",\"74\",\"75\",\"76\",\"77\",\"78\",\"79\",\"80\",\"81\",\"82\",\"83\",\"84\",\"85\",\"86\",\"87\",\"88\",\"89\",\"90\",\"91\",\"92\",\"93\",\"94\",\"95\",\"96\",\"97\",\"98\",\"99\",\"100\"]; setTimeout(function() {\n    $('#slider-n-5').slider({\n        step: 1, min: 0, max: 99, value: 3,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-n-5-lbl').text(values[position]); interact(5, '_interact_.update(\\'5\\', \\'n\\', 8, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'5\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-n-5-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-n-5-lbl').text(values[$('#slider-n-5').slider('value')]);\n    }, 1); })();</script></td>\n</tr><tr><td align=right><font color=\"black\">f&nbsp;</font></td><td><input type=\"text\" value=\"x^2\" size=80 onchange=\"interact(5, '_interact_.update(\\'5\\', \\'f\\', 9, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'5\\');')\"></input></td>\n</tr><tr><td align=right><font color=\"black\">start&nbsp;</font></td><td><input type=\"text\" value=\"0\" size=80 onchange=\"interact(5, '_interact_.update(\\'5\\', \\'start\\', 10, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'5\\');')\"></input></td>\n</tr><tr><td align=right><font color=\"black\">end&nbsp;</font></td><td><input type=\"text\" value=\"1\" size=80 onchange=\"interact(5, '_interact_.update(\\'5\\', \\'end\\', 11, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'5\\');')\"></input></td>\n</tr></table></td></tr>\n<tr><td></td><td style='width: 100%;'><div id=\"cell-interact-5\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td><td></td></tr>\n<tr><td colspan=3></td></tr>\n</table></td>\n                 </tr></table></div>\n                 "}︡
︠a23a9d3c-a469-44e6-8885-b962d6b6b3bd︠
# by Nick Alexander (based on the work of Marshall Hampton)

var('x')
@interact
def midpoint(f = input_box(default = sin(x^2) + 2, type = SR),
    interval=range_slider(0, 10, 1, default=(0, 4), label="Interval"),
    number_of_subdivisions = slider(1, 20, 1, default=4, label="Number of boxes"),
    endpoint_rule = selector(['Midpoint', 'Left', 'Right', 'Upper', 'Lower'], nrows=1, label="Endpoint rule")):

    a, b = map(QQ, interval)
    t = sage.calculus.calculus.var('t')
    func = fast_callable(f(x=t), RDF, vars=[t])
    dx = ZZ(b-a)/ZZ(number_of_subdivisions)
   
    xs = []
    ys = []
    for q in range(number_of_subdivisions):
        if endpoint_rule == 'Left':
            xs.append(q*dx + a)
        elif endpoint_rule == 'Midpoint':
            xs.append(q*dx + a + dx/2)
        elif endpoint_rule == 'Right':
            xs.append(q*dx + a + dx)
        elif endpoint_rule == 'Upper':
            x = find_maximum_on_interval(func, q*dx + a, q*dx + dx + a)[1]
            xs.append(x)
        elif endpoint_rule == 'Lower':
            x = find_minimum_on_interval(func, q*dx + a, q*dx + dx + a)[1]
            xs.append(x)
    ys = [ func(x) for x in xs ]
         
    rects = Graphics()
    for q in range(number_of_subdivisions):
        xm = q*dx + dx/2 + a
        x = xs[q]
        y = ys[q]
        rects += line([[xm-dx/2,0],[xm-dx/2,y],[xm+dx/2,y],[xm+dx/2,0]], rgbcolor = (1,0,0))
        rects += point((x, y), rgbcolor = (1,0,0))
    min_y = min(0, find_minimum_on_interval(func,a,b)[0])
    max_y = max(0, find_maximum_on_interval(func,a,b)[0])

    # html('<h3>Numerical integrals with the midpoint rule</h3>')
    show(plot(func,a,b) + rects, xmin = a, xmax = b, ymin = min_y, ymax = max_y)
    
    def cap(x):
        # print only a few digits of precision
        if x < 1e-4:
            return 0
        return RealField(20)(x)
    sum_html = "%s \cdot \\left[ %s \\right]" % (dx, ' + '.join([ "f(%s)" % cap(i) for i in xs ]))
    num_html = "%s \cdot \\left[ %s \\right]" % (dx, ' + '.join([ str(cap(i)) for i in ys ]))
    
    numerical_answer = integral_numerical(func,a,b,max_points = 200)[0]
    estimated_answer = dx * sum([ ys[q] for q in range(number_of_subdivisions)])

    html(r'''
    <div class="math">
    \begin{align*}
      \int_{a}^{b} {f(x) \, dx} & = %s \\\
      \sum_{i=1}^{%s} {f(x_i) \, \Delta x}
      & = %s \\\
      & = %s \\\
      & = %s .
    \end{align*}
    </div>
    ''' % (numerical_answer, number_of_subdivisions, sum_html, num_html, estimated_answer))
︡b8f26a49-8dbe-4380-b10a-1742d908eb53︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-6\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table>\n<tr><td colspan=3><table><tr><td align=right><font color=\"black\">f&nbsp;</font></td><td><input type=\"text\" value=\"sin(x^2) + 2\" size=80 onchange=\"interact(6, '_interact_.update(\\'6\\', \\'f\\', 12, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'6\\');')\"></input></td>\n</tr><tr><td align=right><font color=\"black\">Interval&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-interval-6\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 20.0em;\"></div>\n        </td></tr><tr><td><font color=\"black\" id=\"slider-interval-6-lbl\"></font></td></tr></table><script>(function()\n    {\n        var values = [\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\"];\n        var pos = [0, 4];\n        var sel = '#slider-interval-6';\n        var updatePos = function()\n        {\n            pos[0]=$(sel).slider('values', 0);\n            pos[1]=$(sel).slider('values', 1);\n            if(values!=null) $(sel+'-lbl').text('('+values[pos[0]]+', '+values[pos[1]]+')');\n        };\n        setTimeout(function()\n        {\n            $(sel).slider(\n            {\n                range: true,\n                step: 1,\n                min: 0,\n                max: 10,\n                values: [0, 4],\n                change: function(e,ui){ updatePos(); interact(6, '_interact_.update(\\'6\\', \\'interval\\', 13, _interact_.standard_b64decode(\\''+encode64(pos[0]+' '+pos[1])+'\\'), globals()); _interact_.recompute(\\'6\\');'); },\n                slide: updatePos\n            });\n            updatePos();\n        }, 1);\n    })();</script></td>\n</tr><tr><td align=right><font color=\"black\">Number of boxes&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-number_of_subdivisions-6\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-number_of_subdivisions-6-lbl\"></font></td></tr></table><script>(function(){ var values = [\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\",\"20\"]; setTimeout(function() {\n    $('#slider-number_of_subdivisions-6').slider({\n        step: 1, min: 0, max: 19, value: 3,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-number_of_subdivisions-6-lbl').text(values[position]); interact(6, '_interact_.update(\\'6\\', \\'number_of_subdivisions\\', 14, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'6\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-number_of_subdivisions-6-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-number_of_subdivisions-6-lbl').text(values[$('#slider-number_of_subdivisions-6').slider('value')]);\n    }, 1); })();</script></td>\n</tr><tr><td align=right><font color=\"black\">Endpoint rule&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:inset;\" value=\"0\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(6, '_interact_.update(\\'6\\', \\'endpoint_rule\\', 15, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'6\\');')\">Midpoint</button>\n<button style=\"border-style:outset;\" value=\"1\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(6, '_interact_.update(\\'6\\', \\'endpoint_rule\\', 15, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'6\\');')\">Left</button>\n<button style=\"border-style:outset;\" value=\"2\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(6, '_interact_.update(\\'6\\', \\'endpoint_rule\\', 15, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'6\\');')\">Right</button>\n<button style=\"border-style:outset;\" value=\"3\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(6, '_interact_.update(\\'6\\', \\'endpoint_rule\\', 15, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'6\\');')\">Upper</button>\n<button style=\"border-style:outset;\" value=\"4\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(6, '_interact_.update(\\'6\\', \\'endpoint_rule\\', 15, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'6\\');')\">Lower</button>\n</td></tr></table></td>\n</tr></table></td></tr>\n<tr><td></td><td style='width: 100%;'><div id=\"cell-interact-6\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td><td></td></tr>\n<tr><td colspan=3></td></tr>\n</table></td>\n                 </tr></table></div>\n                 "}︡
